function serverCmdBanBuilder(%client, %id, %reason)
{
	if(!%client.isSuperAdmin)
		return;

	if(%id == getNumKeyID())
	{
		messageClient(%client, '', "\c5You can't ban the host from building.");
		return;
	}

	if(%id $= "")
		messageClient(%client, '', "\c5No victimBL_ID specified.");
	else
	{
		%cname = %client.name;
		%cid = %client.bl_id;

		if(mFloor(%id) !$= %id)
			%id = -1;

		%group = "BrickGroup_" @ %id;

		%name = %group.name;

		if(isObject(%group.client))
			serverCmdCancelBrick(%group.client);

		%file = new fileObject();

		%file.openForWrite("config/server/bannedBuilders/" @ %id @ ".txt");

		%file.writeLine(%name TAB %cname TAB %cid TAB %reason);

		%file.close();

		%file.delete();

		messageAll('MsgAdminForce', "\c3" @ %cname SPC "\c2permanently banned \c3" @ %name SPC "\c2(ID:" SPC %id @ ") from building - \"" @ %reason @ "\"");

		echo("BUILDER BAN issued by" SPC %cname);
		echo("  +- victim name =" SPC %name);
		echo("  +- victim bl_id =" SPC %id);
		echo("  +- ban reason =" SPC %reason);
	}
}

function banBuilder(%id, %reason)
{
	if(%id $= "")
	{
		echo("Usage: banBuilder(bl_id, reason);");
		return;
	}

	if(mFloor(%id) !$= %id)
		%id = -1;

	%group = "BrickGroup_" @ %id;

	%name = %group.name;

	if(isObject(%group.client))
		serverCmdCancelBrick(%group.client);

	%file = new fileObject();

	%file.openForWrite("config/server/bannedBuilders/" @ %id @ ".txt");

	%file.writeLine(%name TAB "CONSOLE" TAB "-1" TAB %reason);

	%file.close();

	%file.delete();

	messageAll('MsgAdminForce', "\c3 CONSOLE \c2permanently banned \c3" @ %name SPC "\c2(ID:" SPC %id @ ") from building - \"" @ %reason @ "\"");

	echo("BUILDER BAN issued by" SPC "CONSOLE");
	echo("  +- victim name =" SPC %name);
	echo("  +- victim bl_id =" SPC %id);
	echo("  +- ban reason =" SPC %reason);
}

function serverCmdUnbanBuilder(%client, %id)
{
	if(!%client.isSuperAdmin)
		return;

	if(%id $= "")
		return;

	if(mFloor(%id) != %id)
		%id = -1;

	%group = "BrickGroup_" @ %id;

	if(isFile("config/server/bannedBuilders/" @ %id @ ".txt"))
	{
		fileDelete("config/server/bannedBuilders/" @ %id @ ".txt");

		echo(%client.name SPC "unbanned builder" SPC %id);

		if(isObject(%client))
			messageClient(%client, '', "\c5Unbanned builder" SPC %id);

		if(isObject(%group.client))
			messageClient(%group.client, '', "\c5You have been unbanned from building");
	}
}

function unbanBuilder(%id)
{
	if(mFloor(%id) != %id)
		%id = -1;

	%group = "BrickGroup_" @ %id;

	if(isFile("config/server/bannedBuilders/" @ %id @ ".txt"))
	{
		fileDelete("config/server/bannedBuilders/" @ %id @ ".txt");

		echo("Unbanned builder" SPC %id);

		if(isObject(%group.client))
			messageClient(%group.client, '', "\c5You have been unbanned from building");
	}
}

function serverCmdBannedBuilders(%client)
{
	if(!%client.isAdmin)
		return;

	%file = new fileObject();

	messageClient(%client, '', " ");
	messageClient(%client, '', "Banned builders:");

	while((%i = findNextFile("config/server/bannedBuilders/*.txt")) !$= "")
	{
		if(strPos(%i, "*") != -1)
			continue;

		%file.openForRead(%i);

		%line = %file.readLine();

		%id = getSubStr(%i, 30, strLen(%i));
		%id = striReplace(%id, ".txt", "");

		%name = getField(%line, 0);
		%cname = getField(%line, 1);
		%cid = getField(%line, 2);
		%reason = getField(%line, 3);

		messageClient(%client, '', "\c3" @ %id SPC "\c2(" @ %name @ ") by\c3" SPC %cname SPC "\c2(" @ %cid @ ")" SPC "- \"" @ %reason @ "\"");

		%file.close();
		%file.delete();
	}
}

function listBannedBuilders()
{
	%file = new fileObject();

	echo("\nBanned builders:");

	while((%i = findNextFile("config/server/bannedBuilders/*.txt")) !$= "")
	{
		if(strPos(%i, "*") != -1)
			continue;

		%file.openForRead(%i);

		%line = %file.readLine();

		%id = getSubStr(%i, 30, strLen(%i));

		%id = striReplace(%id, ".txt", "");

		%name = getField(%line, 0);

		%cname = getField(%line, 1);

		%cid = getField(%line, 2);

		%reason = getField(%line, 3);

		echo(%id SPC "(" @ %name @ ") by" SPC %cname SPC "(" @ %cid @ ")" SPC "- \"" @ %reason @ "\"");
	}
}

function serverCmdClearBuilderBanList(%client)
{
	if(!%client.isSuperAdmin)
		return;

	%count = 0;

	while((%i = findNextFile("config/server/bannedBuilders/*.txt")) !$= "")
	{
		if(strPos(%i, "*") != -1)
			continue;

		fileDelete(%i);

		%count++;
	}

	if(%count > 0)
	{
		echo("BUILDER BAN LIST CLEARED by" SPC %client.name SPC "BL_ID:" @ %client.bl_id SPC "IP:" @ %client.getRawIP());
		echo("  +- bans cleared =" SPC %count);

		messageAll('MsgClearBricks', "\c3" @ %client.name SPC "\c0cleared the builder banlist.");
	}
}

function clearBuilderBanList()
{
	%count = 0;

	while((%i = findNextFile("config/server/bannedBuilders/*.txt")) !$= "")
	{
		if(strPos(%i, "*") != -1)
			continue;

		fileDelete(%i);

		%count++;
	}

	if(%count > 0)
	{
		echo("BUILDER BAN LIST CLEARED");
		echo("  +- bans cleared =" SPC %count);

		messageAll('MsgClearBricks', "\c3CONSOLE \c0cleared the builder banlist.");
	}
}

function isBannedFromBuilding(%id)
{
	if(isFile("config/server/bannedBuilders/" @ %id @ ".txt"))
		return true;

	return false;
}

package builderBanPackage
{
	function brickDeployProjectile::onCollision(%this, %obj, %col, %fade, %pos, %norm)
	{
		%source = %obj.sourceObject;

		if(%source.getClassName() $= "Player")
		{
			%client = %source.client;

			if(isBannedFromBuilding(%client.bl_id))
			{
				serverCmdCancelBrick(%client);

				messageClient(%client, '', "You are banned from building");
				return;
			}
		}
		Parent::onCollision(%this, %obj, %col, %fade, %pos, %norm);
	}

	function serverCmdPlantBrick(%client)
	{
		if(isBannedFromBuilding(%client.bl_id))
			serverCmdCancelBrick(%client);
		else
			Parent::serverCmdPlantBrick(%client);
	}
};
activatePackage(builderBanPackage);